diff --git a/gcc/analyzer/region-model.h b/gcc/analyzer/region-model.h
index d0ab2c12829..c066cb507ae 100644
--- a/gcc/analyzer/region-model.h
+++ b/gcc/analyzer/region-model.h
@@ -290,6 +3055,31 @@ namespace selftest {
 
 using namespace ::selftest;
 
+/* An implementation of region_model2_context for use in selftests, which
+   stores any pending_diagnostic instances passed to it.  */
+
+class test_region_model2_context : public noop_region_model2_context
+{
+public:
+  void warn (pending_diagnostic *d) FINAL OVERRIDE
+  {
+    m_diagnostics.safe_push (d);
+  }
+
+  unsigned get_num_diagnostics () const { return m_diagnostics.length (); }
+
+  void on_unexpected_tree_code (tree t, const dump_location_t &)
+    FINAL OVERRIDE
+  {
+    internal_error ("unhandled tree code: %qs",
+		    get_tree_code_name (TREE_CODE (t)));
+  }
+
+private:
+  /* Implicitly delete any diagnostics in the dtor.  */
+  auto_delete_vec<pending_diagnostic> m_diagnostics;
+};
+
 /* Attempt to add the constraint (LHS OP RHS) to MODEL.
    Verify that MODEL remains satisfiable.  */
 
@@ -308,31 +3098,43 @@ using namespace ::selftest;
     ASSERT_FALSE (sat);				\
   SELFTEST_END_STMT
 
-/* Assert that REGION_MODEL evaluates the condition "LHS OP RHS"
+/* Implementation detail of the ASSERT_CONDITION_*2 macros.  */
+
+void assert_condition2 (const location &loc,
+			region_model2 &model,
+			const svalue2 *lhs, tree_code op, const svalue2 *rhs,
+			tristate expected);
+
+void assert_condition2 (const location &loc,
+			region_model2 &model,
+			tree lhs, tree_code op, tree rhs,
+			tristate expected);
+
+/* Assert that REGION_MODEL2 evaluates the condition "LHS OP RHS"
    as "true".  */
 
-#define ASSERT_CONDITION_TRUE(REGION_MODEL, LHS, OP, RHS) \
+#define ASSERT_CONDITION_TRUE2(REGION_MODEL2, LHS, OP, RHS)		\
   SELFTEST_BEGIN_STMT							\
-  assert_condition (SELFTEST_LOCATION, REGION_MODEL, LHS, OP, RHS,	\
-		    tristate (tristate::TS_TRUE));		\
+  assert_condition2 (SELFTEST_LOCATION, REGION_MODEL2, LHS, OP, RHS,	\
+		     tristate (tristate::TS_TRUE));			\
   SELFTEST_END_STMT
 
-/* Assert that REGION_MODEL evaluates the condition "LHS OP RHS"
+/* Assert that REGION_MODEL2 evaluates the condition "LHS OP RHS"
    as "false".  */
 
-#define ASSERT_CONDITION_FALSE(REGION_MODEL, LHS, OP, RHS) \
+#define ASSERT_CONDITION_FALSE2(REGION_MODEL2, LHS, OP, RHS) \
   SELFTEST_BEGIN_STMT							\
-  assert_condition (SELFTEST_LOCATION, REGION_MODEL, LHS, OP, RHS,	\
-		    tristate (tristate::TS_FALSE));		\
+  assert_condition2 (SELFTEST_LOCATION, REGION_MODEL2, LHS, OP, RHS,	\
+		     tristate (tristate::TS_FALSE));			\
   SELFTEST_END_STMT
 
-/* Assert that REGION_MODEL evaluates the condition "LHS OP RHS"
+/* Assert that REGION_MODEL2 evaluates the condition "LHS OP RHS"
    as "unknown".  */
 
-#define ASSERT_CONDITION_UNKNOWN(REGION_MODEL, LHS, OP, RHS) \
+#define ASSERT_CONDITION_UNKNOWN2(REGION_MODEL2, LHS, OP, RHS) \
   SELFTEST_BEGIN_STMT							\
-  assert_condition (SELFTEST_LOCATION, REGION_MODEL, LHS, OP, RHS,	\
-		    tristate (tristate::TS_UNKNOWN));		\
+  assert_condition2 (SELFTEST_LOCATION, REGION_MODEL2, LHS, OP, RHS,	\
+		     tristate (tristate::TS_UNKNOWN));			\
   SELFTEST_END_STMT
 
 } /* end of namespace selftest.  */
@@ -341,4 +3143,4 @@ using namespace ::selftest;
 
 } // namespace ana
 
-#endif /* GCC_ANALYZER_REGION_MODEL_H */
+#endif /* GCC_ANALYZER_REGION_MODEL_2_H */
diff --git a/gcc/analyzer/region-model2-impl-calls.cc b/gcc/analyzer/region-model2-impl-calls.cc
index 252e9167b6f..3ef3dd21152 100644
--- a/gcc/analyzer/region-model2-impl-calls.cc
+++ b/gcc/analyzer/region-model2-impl-calls.cc
@@ -51,7 +51,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "digraph.h"
 #include "analyzer/supergraph.h"
 #include "sbitmap.h"
-#include "analyzer/region-model2.h"
+#include "analyzer/region-model.h"
 #include "gimple-pretty-print.h"
 
 #if ENABLE_ANALYZER
diff --git a/gcc/analyzer/region-model2-reachability.cc b/gcc/analyzer/region-model2-reachability.cc
index 337850f523b..6f6a7c4f9a5 100644
--- a/gcc/analyzer/region-model2-reachability.cc
+++ b/gcc/analyzer/region-model2-reachability.cc
@@ -53,8 +53,8 @@ along with GCC; see the file COPYING3.  If not see
 #include "digraph.h"
 #include "analyzer/supergraph.h"
 #include "sbitmap.h"
-#include "analyzer/region-model2.h"
-#include "analyzer/constraint-manager2.h"
+#include "analyzer/region-model.h"
+#include "analyzer/constraint-manager.h"
 #include "diagnostic-event-id.h"
 #include "analyzer/sm.h"
 #include "diagnostic-event-id.h"
diff --git a/gcc/analyzer/sm-file.cc b/gcc/analyzer/sm-file.cc
index a41cd1b5b94..85fbe84999e 100644
--- a/gcc/analyzer/sm-file.cc
+++ b/gcc/analyzer/sm-file.cc
@@ -38,7 +38,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/analyzer-selftests.h"
 #include "tristate.h"
 #include "selftest.h"
-#include "analyzer/region-model2.h"
+#include "analyzer/region-model.h"
 
 #if ENABLE_ANALYZER
 
diff --git a/gcc/analyzer/sm-malloc.cc b/gcc/analyzer/sm-malloc.cc
index 56fb107c39d..ca51da7f2ab 100644
--- a/gcc/analyzer/sm-malloc.cc
+++ b/gcc/analyzer/sm-malloc.cc
@@ -37,7 +37,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "analyzer/pending-diagnostic.h"
 #include "tristate.h"
 #include "selftest.h"
-#include "analyzer/region-model2.h"
+#include "analyzer/region-model.h"
 
 #if ENABLE_ANALYZER
 
diff --git a/gcc/analyzer/store2.cc b/gcc/analyzer/store2.cc
index c9368f4774d..490bef4d774 100644
--- a/gcc/analyzer/store2.cc
+++ b/gcc/analyzer/store2.cc
@@ -51,8 +51,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "digraph.h"
 #include "analyzer/supergraph.h"
 #include "sbitmap.h"
-#include "analyzer/region-model2.h"
-//#include "analyzer/constraint-manager.h"
+#include "analyzer/region-model.h"
 #include "diagnostic-event-id.h"
 #include "analyzer/sm.h"
 #include "diagnostic-event-id.h"
-- 
2.26.2

